package body MSHTML.DispHTMLDOMRange_Object is

   function Get_startContainer
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispHTMLDOMRange_Get_startContainer);
   end Get_startContainer;

   function Get_startOffset
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispHTMLDOMRange_Get_startOffset);
   end Get_startOffset;

   function Get_endContainer
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispHTMLDOMRange_Get_endContainer);
   end Get_endContainer;

   function Get_endOffset
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispHTMLDOMRange_Get_endOffset);
   end Get_endOffset;

   function Get_collapsed
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispHTMLDOMRange_Get_collapsed);
   end Get_collapsed;

   function Get_commonAncestorContainer
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispHTMLDOMRange_Get_commonAncestorContainer);
   end Get_commonAncestorContainer;

   procedure setStart
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      offset  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_setStart,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => offset,
          2 => refNode),
         Free);
   end setStart;

   procedure setEnd
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      offset  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_setEnd,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => offset,
          2 => refNode),
         Free);
   end setEnd;

   procedure setStartBefore
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_setStartBefore,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => refNode),
         Free);
   end setStartBefore;

   procedure setStartAfter
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_setStartAfter,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => refNode),
         Free);
   end setStartAfter;

   procedure setEndBefore
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_setEndBefore,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => refNode),
         Free);
   end setEndBefore;

   procedure setEndAfter
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_setEndAfter,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => refNode),
         Free);
   end setEndAfter;

   procedure collapse
     (This    : DispHTMLDOMRange_Type;
      toStart : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_collapse,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toStart),
         Free);
   end collapse;

   procedure selectNode
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_selectNode,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => refNode),
         Free);
   end selectNode;

   procedure selectNodeContents
     (This    : DispHTMLDOMRange_Type;
      refNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_selectNodeContents,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => refNode),
         Free);
   end selectNodeContents;

   function compareBoundaryPoints
     (This        : DispHTMLDOMRange_Type;
      how         : GNATCOM.Types.VARIANT;
      sourceRange : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         DispHTMLDOMRange_compareBoundaryPoints,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => sourceRange,
          2 => how),
         Free);
   end compareBoundaryPoints;

   procedure deleteContents
     (This : DispHTMLDOMRange_Type)
   is
   begin
      Invoke (This, DispHTMLDOMRange_deleteContents);
   end deleteContents;

   function extractContents
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, DispHTMLDOMRange_extractContents);
   end extractContents;

   function cloneContents
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, DispHTMLDOMRange_cloneContents);
   end cloneContents;

   procedure insertNode
     (This    : DispHTMLDOMRange_Type;
      newNode : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_insertNode,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => newNode),
         Free);
   end insertNode;

   procedure surroundContents
     (This      : DispHTMLDOMRange_Type;
      newParent : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispHTMLDOMRange_surroundContents,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => newParent),
         Free);
   end surroundContents;

   function cloneRange
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, DispHTMLDOMRange_cloneRange);
   end cloneRange;

   function toString
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, DispHTMLDOMRange_toString);
   end toString;

   procedure Detach
     (This : DispHTMLDOMRange_Type)
   is
   begin
      Invoke (This, DispHTMLDOMRange_Detach);
   end Detach;

   function getClientRects
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, DispHTMLDOMRange_getClientRects);
   end getClientRects;

   function getBoundingClientRect
     (This : DispHTMLDOMRange_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, DispHTMLDOMRange_getBoundingClientRect);
   end getBoundingClientRect;

end MSHTML.DispHTMLDOMRange_Object;

